# sfs-mc
More than a web server that dynamically show the status of a Minecraft server (formerly known as bukkit-server-status)

# Goals
- [ ] A cli (using [`clap`](https://crates.io/crates/clap/)) that enables to
    - [ ] Start the Minecraft server and give control over its terminal (using [`screen`](https://www.gnu.org/software/screen/))
    - [ ] Start and control the webserver
        - [ ] Turn on/off remote starting of the Minecraft server
- [ ] A webserver that show the current status of the Minecraft server (using [`actix-web`](https://crates.io/crates/actix-web/), [`tokio`](https://crates.io/crates/tokio/), and [`async-minecraft-ping`](https://crates.io/crates/async-minecraft-ping/))
    - [ ] Server online
    - [ ] Players online
    - [ ] MOTD
    - [ ] Start the Minecraft server if offline
- [ ] Config loading (using [`toml`](https://crates.io/crates/toml/))
- [ ] Config profiles
- [ ] Running in the background (using [`screen`](https://www.gnu.org/software/screen/))

# Decisions made along the way
## 4th August 2020
For the server and "client" to be able to communicate with eachother, I'll be using [DBus](https://www.freedesktop.org/wiki/Software/dbus/) and the [`dbus`-crate](https://crates.io/crates/dbus/). Also, it will probably be better to split the server and client/daemon and control utility in two separate projects (using Cargo's [workspaces](https://doc.rust-lang.org/cargo/reference/workspaces.html)).